set rcsId {$Id: scroll.tcl,v 1.3 1998/04/27 21:00:50 jfontain Exp $}

# generic scroll widget with automatic scrollbars for scrolling widgets with the common tk scroll interface

class scroll {

    proc scroll {this scrollableClass parentPath args} composite {[new frame $parentPath] $args} {
        # scrollable class widget must accept the -[xy]scrollcommand options and [xy]view commands, such as canvas, text, table, ...
        set path $widget::($this,path)
        composite::manage $this [new $scrollableClass $path] scrolled\
            [new scrollbar $path -orient horizontal] horizontal [new scrollbar $path] vertical

        widget::configure $composite::($this,scrolled)\
            -xscrollcommand "scroll::update $this $composite::($this,horizontal,path) 0 1"\
            -yscrollcommand "scroll::update $this $composite::($this,vertical,path) 1 0"
        widget::configure $composite::($this,horizontal) -command "$composite::($this,scrolled,path) xview"
        widget::configure $composite::($this,vertical) -command "$composite::($this,scrolled,path) yview"

        grid $composite::($this,scrolled,path) -sticky nsew
        grid rowconfigure $path 0 -weight 1
        grid columnconfigure $path 0 -weight 1

        composite::complete $this
    }

    proc ~scroll {this} {}

    proc options {this} {
        return [list\
            [list -automatic automatic Automatic 1 1]\
        ]
    }

    proc update {this barPath column row first last} {
        set visible [llength [grid info $barPath]]
        if {!$composite::($this,-automatic)||(($last-$first)<1)} {
            # in automatic mode, scrollbar is required when only part of scrolled widget is visible
            grid propagate $widget::($this,path) 0 ;# required to avoid infinite vibrations. must be done at every update and I do
            # not understand why once would not be enough. furthermore, this is the only place in the code where it seems to work.
            if {!$visible} {
                grid $barPath -column $column -row $row -sticky nsew                                                       ;# map it
            }
            foreach {previousFirst previousLast} [$barPath get] {}
            if {($first!=$previousFirst)||($last!=$previousLast)} {                                    ;# update only when necessary
                $barPath set $first $last
            }
        } else {                                     ;# in automatic mode, no need for a scrollbar since whole dimension can be seen
            if {$visible} {
                grid remove $barPath
            }
        }
    }

}
